unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, AppEvnts, StdCtrls;

type
  TForm1 = class(TForm)
    ApplicationEvents1: TApplicationEvents;
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure ApplicationEventsIdle(Sender: TObject; var Done: Boolean);
    procedure FormClick(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  PolyPoints : Array of TPoint;
  anzPoints : integer;
  ClickPoint : TPoint;

implementation

{$R *.dfm}

{
int point_in_poly( POINT *poly_verts, int num_verts, POINT *test_point )
{
	int nx, ny, loop;

//	Clockwise order.

	for ( loop = 0; loop < num_verts; loop++ )
	{
	//	generate a 2d normal ( no need to normalise ).
		nx = poly_verts[ ( loop + 1 ) % num_verts ].y - poly_verts[ loop ].y;
		ny = poly_verts[ loop ].x - poly_verts[ ( loop + 1 ) % num_verts ].x;

		x = test_point->x - poly_verts[ loop ].x;
		y = test_point->y - poly_verts[ loop ].y;

	//	Dot with edge normal to find side.
		if ( ( x * nx ) + ( y * ny ) > 0 )
			return 0;
	//}

//	return 1;
//}

function Point_inPoly(cPoint : TPoint; const Points: Array of TPoint ): Boolean;
var Count, K, J : Integer;
    X,Y: Integer;
begin
  X := cPoint.X;
  y := cPoint.Y;
  Result := False;
  Count := Length(Points) ;
  J := Count-1;
  for K := 0 to Count-1 do begin
   if ((Points[K].Y <=Y) and (Y < Points[J].Y)) or
      ((Points[J].Y <=Y) and (Y < Points[K].Y)) then
   begin
    if (x < (Points[j].X - Points[K].X) *
       (y - Points[K].Y) /
       (Points[j].Y - Points[K].Y) + Points[K].X) then
        Result := not Result;
    end;
    J := K;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     SetLength(PolyPoints,2);
     PolyPoints[0] := Point(150,125);
     PolyPoints[1] := Point(250,125);
     ClickPoint := Point(1,1);




     Application.OnIdle := ApplicationEventsIdle;
end;


procedure TForm1.ApplicationEventsIdle(Sender: TObject; var Done: Boolean);
var i : integer;
    a : TColor;
    b : TBitmap;
begin
     B := TBitmap.Create;
     b.Width := Form1.ClientWidth;
     b.Height := Form1.ClientHeight;


     // Erstmal Punkte ausgeben
     anzPoints := Length(PolyPoints);
     for i := 0 to anzPoints - 1 do
     begin
          b.Canvas.Pixels[PolyPoints[i].X-1,PolyPoints[i].Y-1] := clred;
          b.Canvas.Pixels[PolyPoints[i].X,PolyPoints[i].Y-1] := clred;
          b.Canvas.Pixels[PolyPoints[i].X+1,PolyPoints[i].Y-1] := clred;
          b.Canvas.Pixels[PolyPoints[i].X-1,PolyPoints[i].Y] := clred;
          b.Canvas.Pixels[PolyPoints[i].X,PolyPoints[i].Y] := clred;
          b.Canvas.Pixels[PolyPoints[i].X+1,PolyPoints[i].Y] := clred;
          b.Canvas.Pixels[PolyPoints[i].X-1,PolyPoints[i].Y+1] := clred;
          b.Canvas.Pixels[PolyPoints[i].X,PolyPoints[i].Y+1] := clred;
          b.Canvas.Pixels[PolyPoints[i].X+1,PolyPoints[i].Y+1] := clred;
     end;
     // Verbindungen zeichnen
     b.Canvas.MoveTo(PolyPoints[0].x,PolyPoints[0].y);
     b.Canvas.TextOut(PolyPoints[0].x,PolyPoints[0].y,InttoStr(0));
     for i := 1 to anzPoints - 1 do
     begin
          b.Canvas.LineTo(PolyPoints[i].x,PolyPoints[i].y);
          b.Canvas.TextOut(PolyPoints[i].x,PolyPoints[i].y,InttoStr(i));
          b.Canvas.MoveTo(PolyPoints[i].x,PolyPoints[i].y);
     end;
     b.Canvas.LineTo(PolyPoints[0].x,PolyPoints[0].y);

     if Point_inPoly(ClickPoint,PolyPoints) = true then
     begin
          a := clBlue;
     end
     else
     begin
          a := clGreen;
     end;

     // ClickPoint Zeichnen
          b.Canvas.Pixels[ClickPoint.X-2,ClickPoint.Y-2] := a;
          b.Canvas.Pixels[ClickPoint.X-1,ClickPoint.Y-2] := a;
          b.Canvas.Pixels[ClickPoint.X  ,ClickPoint.Y-2] := a;
          b.Canvas.Pixels[ClickPoint.X+1,ClickPoint.Y-2] := a;
          b.Canvas.Pixels[ClickPoint.X+2,ClickPoint.Y-2] := a;
          b.Canvas.Pixels[ClickPoint.X-2,ClickPoint.Y+2] := a;
          b.Canvas.Pixels[ClickPoint.X-1,ClickPoint.Y+2] := a;
          b.Canvas.Pixels[ClickPoint.X  ,ClickPoint.Y+2] := a;
          b.Canvas.Pixels[ClickPoint.X+1,ClickPoint.Y+2] := a;
          b.Canvas.Pixels[ClickPoint.X+2,ClickPoint.Y+2] := a;

          b.Canvas.Pixels[ClickPoint.X-1,ClickPoint.Y-1] := a;
          b.Canvas.Pixels[ClickPoint.X  ,ClickPoint.Y-1] := a;
          b.Canvas.Pixels[ClickPoint.X+1,ClickPoint.Y-1] := a;
          b.Canvas.Pixels[ClickPoint.X-1,ClickPoint.Y] := a;
          b.Canvas.Pixels[ClickPoint.X  ,ClickPoint.Y] := a;
          b.Canvas.Pixels[ClickPoint.X+1,ClickPoint.Y] := a;
          b.Canvas.Pixels[ClickPoint.X-1,ClickPoint.Y+1] := a;
          b.Canvas.Pixels[ClickPoint.X  ,ClickPoint.Y+1] := a;
          b.Canvas.Pixels[ClickPoint.X+1,ClickPoint.Y+1] := a;

     // Listbox Fllen
     ListBox1.Clear;
     for i := 0 to anzPoints - 1 do
     begin
          ListBox1.Items.Add(InttoStr(i) + ' ' + Inttostr(PolyPoints[i].X) + ' ' + Inttostr(PolyPoints[i].Y));
     end;

     // Windows denken lassen, das wir noch nicht fertig wren
     Done := False;
     Form1.Canvas.Draw(0,0,b);
     b.Destroy;
end;

procedure TForm1.FormClick(Sender: TObject);
begin
     ClickPoint.x := mouse.CursorPos.x - form1.left;
     ClickPoint.y := mouse.CursorPos.y - form1.top - 16;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     ClickPoint.x := X;
     ClickPoint.y := Y;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     SetLength(PolyPoints,Length(PolyPoints)+1);
     PolyPoints[Length(PolyPoints)-1] := Point(X,Y);
end;

end.
